package amiga;

public final class Scenery {

	/** Angle, 256 = 360 deg, unsigned byte */
	static byte[] mountain_positions = new byte[ 48 ];

	static byte[] mountain_numbers = new byte[ 48 ];

	static byte mountain_poly_edges = 0;

	static byte mountain_total_edges = 0;

	static byte mountain_poly_count = 0;

	static byte mountain_count = 0;

	static short mountain_x_offset = 0;

	static short mountain_y_offset = 0;
/*
	standard
	dc.w	4
	dc.w	0,0,0x80c8,0,0x804b,0x8019,0x8078,0x801e
	dc.b	4
	dc.b	0,2,0,4,4,6,2,6
	dc.b	1

	dc.b	5
	dc.b	4
	dc.b	0,4,8,12

taller	dc.w	4
	dc.w	0,0,0x80c8,0,0x80fa,0,0x8050,0x801e
	dc.b	5
	dc.b	0,2,2,4,0,6,2,6,4,6
	dc.b	2

	dc.b	4
	dc.b	3
	dc.b	0,8,12

	dc.b	5
	dc.b	3
	dc.b	4,12,16

snow.capped
	dc.w	7
	dc.w	0,0,0x81f4,0,0x8348,0,0x84a6,0,0x8302,0x805c
	dc.w	0x8230,0x8069,0x833e,0x80e6
	dc.b	10
	dc.b	0,2,2,4,4,6,0,10,2,8,4,8,6,12,8,10,10,12,8,12
	dc.b	4

	dc.b	4
	dc.b	4
	dc.b	0,12,28,16

	dc.b	5
	dc.b	3
	dc.b	4,16,20

	dc.b	5
	dc.b	4
	dc.b	8,20,36,24

	dc.b	15
	dc.b	3
	dc.b	28,32,36

buildings
	dc.w	6
	dc.w	0,0,0x805a,0,0x808c,0,0,0x8140,0x805a,0x8140,0x808c,0x8140
	dc.b	7
	dc.b	0,2,2,4,0,6,2,8,4,10,6,8,8,10
	dc.b	2

	dc.b	15
	dc.b	4
	dc.b	0,8,20,12

	dc.b	14
	dc.b	4
	dc.b	4,12,24,16

lake	dc.w	4
	dc.w	0,8,0x32,0,0x28a,0,0x2bc,8
	dc.b	4
	dc.b	2,4,0,2,0,6,4,6
	dc.b	1

	dc.b	6
	dc.b	4
	dc.b	0,4,8,12

sm1	dc.w	0x180,0x4b,0x1c,0x104,0x10
sm2	dc.w	0x100,0x7d,0x12,0xc0,0x1e
sm3	dc.w	0x180,0x64,0x14,0x136,0x25
sm4	dc.w	0x100,0x46,0x18,0xd8,0x24
sm5	dc.w	0x180,0xc8,0x27,0xf0,0x1f
sm6	dc.w	0x100,0x32,0xc,0xa8,0x1a
sm7	dc.w	0x172,0x70,0x19,0xe6,0x14
sm8	dc.w	0xfa,0x64,0xc,0xbb,0x12
sm9	dc.w	0x180,0xc6,0x1c,0x13b,0x18
smA	dc.w	0x100,0x23,0x28,0x6e,0x37
smB	dc.w	0x159,0x5c,0x2a,0xf0,0x1e
smC	dc.w	0xfa,0x2d,0xf,0x80,0xb
smD	dc.w	0x17c,0x88,0x2b,0xd2,0x23
smE	dc.w	0x100,0x4b,0x29,0x9b,0x37

	dc.w	0x64,0x19a,0xfa,0x2d,0x4b,0x23f,0xaa,0x2d
	dc.w	0xb9,0x145,0x7d,0x46,0x32,0x12c,0xa5,0x15

scm1	dc.w	0xfa,0x1a4,0x253,0x181,0x2e,0x118,0x34,0x19f,0x73
scm2	dc.w	0x4b,0x127,0x1f4,0xaf,0x32,0x87,0x3c,0xff,0x48
scm3	dc.w	0x87,0xc5,0xfa,0x96,0x46,0x69,0x50,0xaa,0x5f
scm4	dc.w	0x87,0x113,0x1a9,0x91,0x2a,0x3c,0x32,0x8c,0x4d

bm1	dc.w	0x10,0x18,0x50,0x10,0x50,0x18,0x50
bm2	dc.w	0x10,0x18,0x3c,0x10,0x3c,0x18,0x3c
bm3	dc.w	0x28,0x3c,0x39,0x28,0x39,0x3c,0x39
bm4	dc.w	0x69,0x7d,0x2a,0x69,0x2a,0x7d,0x2a

lm	dc.w	0

mountain.table
	dc.l	standard,sm1
	dc.l	standard,sm2
	dc.l	standard,sm3
	dc.l	standard,sm4
	dc.l	standard,sm5
	dc.l	standard,sm6
	dc.l	standard,sm7
	dc.l	standard,sm8
	dc.l	standard,sm9
	dc.l	standard,smA
	dc.l	standard,smB
	dc.l	standard,smC
	dc.l	standard,smD
	dc.l	standard,smE
	dc.l	taller,smD
	dc.l	taller,smE
	dc.l	snow.capped,scm1
	dc.l	snow.capped,scm2
	dc.l	snow.capped,scm3
	dc.l	snow.capped,scm4
	dc.l	buildings,bm1
	dc.l	buildings,bm2
	dc.l	buildings,bm3
	dc.l	buildings,bm4
	dc.l	lake,lm
*/
//mountain.table2
//	dc.l	positions.and.numbers,positions.and.numbers

	static final class SceneryData {
		short mNumCountLen2;
		short[] mWdata;
		byte[] mBdata;

		SceneryData(short len, short[] w, byte[] b) {
			mNumCountLen2 = len;
			mWdata = w;
			mBdata = b;
		}
	}

	static final class SceneryDataBinding {
		SceneryData mSceneryData;
		short[] mNumbers;

		SceneryDataBinding(SceneryData d, short[] n) {
			mSceneryData = d;
			mNumbers = n;
		}
	}

	static SceneryData standard = new SceneryData(
			(short) 4,
			new short[] {// x, y
					(short) 0, (short) 0,
					(short) 0x80c8, (short) 0,
					(short) 0x804b, (short) 0x8019,
					(short) 0x8078, (short) 0x801e
			},
			new byte[] {
					4,// total_edges
					0, 2, 0, 4, 4, 6, 2, 6,// 2 x total_edges, (p1,p2), (p1,p2),...
					1,// poly_count

					5,// color index
					4,// poly edges
					0, 4, 8, 12// 0, 8, 12, 4, // java needs clockwise, Amiga uses: 0, 4, 8, 12
			}
	);

	static SceneryData taller = new SceneryData(
			(short) 4,// total_edges
			new short[] {// x, y
					0, 0,
					(short) 0x80c8, 0,
					(short) 0x80fa, 0,
					(short) 0x8050, (short) 0x801e
			},
			new byte[] {
					5,// total_edges
					// (p1,p2), (p1,p2)
					0, 2, 2, 4, 0, 6, 2, 6, 4, 6,
					2,// poly_count

					4,// color index
					3,// poly edges
					0, 8, 12,

					5,// color index
					3,// poly edges
					4, 12, 16
			}
	);

	static SceneryData snow_capped = new SceneryData(
			(short) 7,// total_edges
			new short[] {// x, y
					0, (short) 0,
					(short) 0x81f4, (short) 0,
					(short) 0x8348, (short) 0,
					(short) 0x84a6, (short) 0,
					(short) 0x8302, (short) 0x805c,
					(short) 0x8230, (short) 0x8069,
					(short) 0x833e, (short) 0x80e6
			},
			new byte[] {
					10,// total_edges
					// (p1,p2), (p1,p2)
					0, 2, 2, 4, 4, 6, 0, 10, 2, 8, 4, 8, 6, 12, 8, 10, 10, 12, 8, 12,
					4,// poly_count

					4,// color index
					4,// poly edges
					0, 12, 28, 16,

					5,// color index
					3,// poly edges
					4, 16, 20,

					5,// color index
					4,// poly edges
					8, 20, 36, 24,

					15,// color index
					3,// poly edges
					28, 32, 36
			}
	);

	static SceneryData buildings = new SceneryData(
			(short) 6,// total_edges
			new short[] {// x, y
					0, 0,
					(short) 0x805a, 0,
					(short) 0x808c, 0,
					0, (short) 0x8140,
					(short) 0x805a, (short) 0x8140,
					(short) 0x808c, (short) 0x8140
			},
			new byte[] {
					7,// total_edges
					// (p1,p2), (p1,p2)
					0, 2, 2, 4, 0, 6, 2, 8, 4, 10, 6, 8, 8, 10,
					2,// poly_count

					15,// color index
					4,// poly edges
					0, 8, 20, 12,

					14,// color index
					4,// poly edges
					4, 12, 24, 16
			}
	);

	static SceneryData lake = new SceneryData(
			(short) 4,// total_edges
			new short[] {// x, y
					0, 8,
					0x32, 0,
					0x28a, 0,
					0x2bc, 8
			},
			new byte[] {
					4,// total_edges
					// (p1,p2), (p1,p2)
					2, 4, 0, 2, 0, 6, 4, 6,
					1,// poly_count

					6,// color index
					4,// poly edges
					0, 4, 8, 12
			}
	);

	static short[] sm1 = { 0x180, 0x4b, 0x1c, 0x104, 0x10 };
	static short[] sm2 = { 0x100, 0x7d, 0x12, 0xc0, 0x1e };
	static short[] sm3 = { 0x180, 0x64, 0x14, 0x136, 0x25 };
	static short[] sm4 = { 0x100, 0x46, 0x18, 0xd8, 0x24 };
	static short[] sm5 = { 0x180, 0xc8, 0x27, 0xf0, 0x1f };
	static short[] sm6 = { 0x100, 0x32, 0xc, 0xa8, 0x1a };
	static short[] sm7 = { 0x172, 0x70, 0x19, 0xe6, 0x14 };
	static short[] sm8 = { 0xfa, 0x64, 0xc, 0xbb, 0x12 };
	static short[] sm9 = { 0x180, 0xc6, 0x1c, 0x13b, 0x18 };
	static short[] smA = { 0x100, 0x23, 0x28, 0x6e, 0x37 };
	static short[] smB = { 0x159, 0x5c, 0x2a, 0xf0, 0x1e };
	static short[] smC = { 0xfa, 0x2d, 0xf, 0x80, 0xb };
	static short[] smD = { 0x17c, 0x88, 0x2b, 0xd2, 0x23 };
	static short[] smE = { 0x100, 0x4b, 0x29, 0x9b, 0x37 };

	static short[] scm1 = { 0xfa, 0x1a4, 0x253, 0x181, 0x2e, 0x118, 0x34, 0x19f, 0x73 };
	static short[] scm2 = { 0x4b, 0x127, 0x1f4, 0xaf, 0x32, 0x87, 0x3c, 0xff, 0x48 };
	static short[] scm3 = { 0x87, 0xc5, 0xfa, 0x96, 0x46, 0x69, 0x50, 0xaa, 0x5f };
	static short[] scm4 = { 0x87, 0x113, 0x1a9, 0x91, 0x2a, 0x3c, 0x32, 0x8c, 0x4d };

	static short[] bm1 = { 0x10, 0x18, 0x50, 0x10, 0x50, 0x18, 0x50 };
	static short[] bm2 = { 0x10, 0x18, 0x3c, 0x10, 0x3c, 0x18, 0x3c };
	static short[] bm3 = { 0x28, 0x3c, 0x39, 0x28, 0x39, 0x3c, 0x39 };
	static short[] bm4 = { 0x69, 0x7d, 0x2a, 0x69, 0x2a, 0x7d, 0x2a };

	static short[] lm = { 0 };

	static SceneryDataBinding[] mountain_table = {
			new SceneryDataBinding( standard, sm1 ),
			new SceneryDataBinding( standard, sm2 ),
			new SceneryDataBinding( standard, sm3 ),
			new SceneryDataBinding( standard, sm4 ),
			new SceneryDataBinding( standard, sm5 ),
			new SceneryDataBinding( standard, sm6 ),
			new SceneryDataBinding( standard, sm7 ),
			new SceneryDataBinding( standard, sm8 ),
			new SceneryDataBinding( standard, sm9 ),
			new SceneryDataBinding( standard, smA ),
			new SceneryDataBinding( standard, smB ),
			new SceneryDataBinding( standard, smC ),
			new SceneryDataBinding( standard, smD ),
			new SceneryDataBinding( standard, smE ),
			new SceneryDataBinding( taller, smD ),
			new SceneryDataBinding( taller, smE ),
			new SceneryDataBinding( snow_capped, scm1 ),
			new SceneryDataBinding( snow_capped, scm2 ),
			new SceneryDataBinding( snow_capped, scm3 ),
			new SceneryDataBinding( snow_capped, scm4 ),
			new SceneryDataBinding( buildings, bm1 ),
			new SceneryDataBinding( buildings, bm2 ),
			new SceneryDataBinding( buildings, bm3 ),
			new SceneryDataBinding( buildings, bm4 ),
			new SceneryDataBinding( lake, lm ),
	};

	static byte[] positions_and_numbers = {
			32,// mountain count
			0x05, 0, 0x0f, 13, 0x15, 10, 0x1f, 11, 0x25, 12, 0x2f, 5, 0x35, 2, 0x3f, 3,
			0x45, 0, 0x4f, 1, 0x55, 4, 0x5f, 5, 0x65, 2, 0x6f, 1, 0x75, 0, 0x7f, 5,
			(byte) 0x85, 2, (byte) 0x8f, 3, (byte) 0x95, 4, (byte) 0x9f, 5, (byte) 0xa5, 0, (byte) 0xaf, 9, (byte) 0xb5, 6, (byte) 0xbf, 7,
			(byte) 0xc5, 8, (byte) 0xcf, 5, (byte) 0xd5, 0, (byte) 0xdf, 3, (byte) 0xe5, 4, (byte) 0xef, 1, (byte) 0xf5, 2, (byte) 0xff, 5,
			0
	};

	// 26353 initialise.mountains
	public static void initialiseMountains() {

		// mountain.table2[ index ]
		int a2i = 0;
		mountain_count = positions_and_numbers[ a2i++ ];
		for( int i = 0; i < mountain_count; i++ ) {
			mountain_positions[ i ] = positions_and_numbers[ a2i++ ];
			mountain_numbers[ i ] = positions_and_numbers[ a2i++ ];
		}
	}
}
