package amiga;

public final class Text {

	static final int COLUMN_NORMAL_FONT_WIDTH = 7;
	static final int COLUMN_SMALL_FONT_WIDTH = 6;
	static final int TEXT_ROW_HEIGHT = 8;

	static final int COLUMN_NORMAL_FONT_BITS = 8;
	static final int COLUMN_SMALL_FONT_BITS = 6;

	// font7 is changed in {@link #mainInitialisation}
	static final byte[] font7 = {// chars. 32 to 126
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00,// ' '
			(byte) 0x95, (byte) 0x95, (byte) 0x95, (byte) 0x95, (byte) 0xaa, (byte) 0xea, (byte) 0xea, (byte) 0xea,// !
			(byte) 0x15, (byte) 0x15, (byte) 0x15, (byte) 0x15, (byte) 0x15, (byte) 0x6a, (byte) 0x6a, (byte) 0x6a,// ~
			(byte) 0x75, (byte) 0xc3, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x80,// "
			(byte) 0x40, (byte) 0x40, (byte) 0xc0, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x80, (byte) 0x80,// #
			(byte) 0x55, (byte) 0x55, (byte) 0x55, (byte) 0x55, (byte) 0x55, (byte) 0xaa, (byte) 0xaa, (byte) 0xaa,// $
			(byte) 0x55, (byte) 0x55, (byte) 0x55, (byte) 0x55, (byte) 0x55, (byte) 0xaa, (byte) 0xaa, (byte) 0xaa,// %
			(byte) 0xbd, (byte) 0xff, (byte) 0xc3, (byte) 0xc0, (byte) 0xc3, (byte) 0xf3, (byte) 0xbf, (byte) 0xbf,// &
			(byte) 0x00, (byte) 0x00, (byte) 0xc0, (byte) 0xc0, (byte) 0xc0, (byte) 0xc0, (byte) 0x40, (byte) 0x40,// '
			(byte) 0xff, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0x80,// (
			(byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0x80, (byte) 0xff,// )
			(byte) 0x08, (byte) 0x08, (byte) 0x08, (byte) 0x7f, (byte) 0x08, (byte) 0x08, (byte) 0x08, (byte) 0x00,// *
			(byte) 0x01, (byte) 0x01, (byte) 0x01, (byte) 0x01, (byte) 0x01, (byte) 0x01, (byte) 0x01, (byte) 0xff,// +
			// (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x7f, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00,// '-'
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x7e, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00,// '-'
			// (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x00,// '.'
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x00,// '.'
			(byte) 0x00, (byte) 0x02, (byte) 0x04, (byte) 0x08, (byte) 0x10, (byte) 0x20, (byte) 0x40, (byte) 0x00,// /
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x3c, (byte) 0x00,// 0
			(byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x38, (byte) 0x00,// 1
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x0c, (byte) 0x30, (byte) 0x40, (byte) 0x7e, (byte) 0x00,// 2
			(byte) 0x00, (byte) 0x7e, (byte) 0x04, (byte) 0x0c, (byte) 0x02, (byte) 0x42, (byte) 0x3c, (byte) 0x00,// 3
			(byte) 0x00, (byte) 0x04, (byte) 0x0c, (byte) 0x14, (byte) 0x24, (byte) 0x7e, (byte) 0x04, (byte) 0x00,// 4
			(byte) 0x00, (byte) 0x7e, (byte) 0x40, (byte) 0x7c, (byte) 0x02, (byte) 0x02, (byte) 0x7c, (byte) 0x00,// 5
			(byte) 0x00, (byte) 0x3c, (byte) 0x40, (byte) 0x7c, (byte) 0x42, (byte) 0x42, (byte) 0x3c, (byte) 0x00,// 6
			(byte) 0x00, (byte) 0x7e, (byte) 0x04, (byte) 0x08, (byte) 0x10, (byte) 0x20, (byte) 0x20, (byte) 0x00,// 7
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x3c, (byte) 0x42, (byte) 0x42, (byte) 0x3c, (byte) 0x00,// 8
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x3c, (byte) 0x04, (byte) 0x08, (byte) 0x10, (byte) 0x00,// 9
			(byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x00, (byte) 0x00,// :
			(byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x20, (byte) 0x00,// ;
			(byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x18, (byte) 0x00, (byte) 0x18, (byte) 0x00,// <
			(byte) 0x00, (byte) 0x00, (byte) 0x7e, (byte) 0x00, (byte) 0x7e, (byte) 0x00, (byte) 0x00, (byte) 0x00,// =
			(byte) 0x30, (byte) 0x18, (byte) 0x0c, (byte) 0x06, (byte) 0x0c, (byte) 0x18, (byte) 0x30, (byte) 0x00,// >
			(byte) 0x00, (byte) 0x38, (byte) 0x44, (byte) 0x04, (byte) 0x08, (byte) 0x10, (byte) 0x00, (byte) 0x10,// ?
			(byte) 0x3c, (byte) 0x66, (byte) 0x6e, (byte) 0x6a, (byte) 0x6e, (byte) 0x60, (byte) 0x3c, (byte) 0x00,// @
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x42, (byte) 0x7e, (byte) 0x42, (byte) 0x42, (byte) 0x00,// A
			(byte) 0x00, (byte) 0x78, (byte) 0x44, (byte) 0x7c, (byte) 0x42, (byte) 0x42, (byte) 0x7c, (byte) 0x00,// B
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x40, (byte) 0x40, (byte) 0x42, (byte) 0x3c, (byte) 0x00,// C
			(byte) 0x00, (byte) 0x7c, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x7c, (byte) 0x00,// D
			(byte) 0x00, (byte) 0x7e, (byte) 0x40, (byte) 0x78, (byte) 0x40, (byte) 0x40, (byte) 0x7e, (byte) 0x00,// E
			(byte) 0x00, (byte) 0x7e, (byte) 0x40, (byte) 0x78, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x00,// F
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x40, (byte) 0x4e, (byte) 0x42, (byte) 0x3e, (byte) 0x00,// G
			(byte) 0x00, (byte) 0x42, (byte) 0x42, (byte) 0x7e, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x00,// H
			(byte) 0x00, (byte) 0x38, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x38, (byte) 0x00,// I
			(byte) 0x00, (byte) 0x04, (byte) 0x04, (byte) 0x04, (byte) 0x04, (byte) 0x44, (byte) 0x38, (byte) 0x00,// J
			(byte) 0x00, (byte) 0x44, (byte) 0x48, (byte) 0x70, (byte) 0x48, (byte) 0x44, (byte) 0x42, (byte) 0x00,// K
			(byte) 0x00, (byte) 0x20, (byte) 0x20, (byte) 0x20, (byte) 0x20, (byte) 0x20, (byte) 0x3e, (byte) 0x00,// L
			(byte) 0x00, (byte) 0x42, (byte) 0x66, (byte) 0x5a, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x00,// M
			(byte) 0x00, (byte) 0x42, (byte) 0x62, (byte) 0x52, (byte) 0x4a, (byte) 0x46, (byte) 0x42, (byte) 0x00,// N
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x3c, (byte) 0x00,// O
			(byte) 0x00, (byte) 0x7c, (byte) 0x42, (byte) 0x7c, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x00,// P
			(byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x3c, (byte) 0x06,// Q
			(byte) 0x00, (byte) 0x7c, (byte) 0x42, (byte) 0x7c, (byte) 0x48, (byte) 0x44, (byte) 0x42, (byte) 0x00,// R
			(byte) 0x00, (byte) 0x3e, (byte) 0x40, (byte) 0x3c, (byte) 0x02, (byte) 0x02, (byte) 0x7c, (byte) 0x00,// S
			(byte) 0x00, (byte) 0x7c, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x00,// T
			(byte) 0x00, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x3e, (byte) 0x00,// U
			(byte) 0x00, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x24, (byte) 0x18, (byte) 0x00,// V
			(byte) 0x00, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x5a, (byte) 0x66, (byte) 0x42, (byte) 0x00,// W
			(byte) 0x00, (byte) 0x42, (byte) 0x24, (byte) 0x18, (byte) 0x18, (byte) 0x24, (byte) 0x42, (byte) 0x00,// X
			(byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x28, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x00,// Y
			(byte) 0x00, (byte) 0x7e, (byte) 0x04, (byte) 0x08, (byte) 0x10, (byte) 0x20, (byte) 0x7e, (byte) 0x00,// Z
			(byte) 0x01, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff,// [
			(byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff,// \
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x01,// ]
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80,// ^
			// (byte) 0x01, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x01,// _
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x7e, (byte) 0x01,// _
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff,// '
			(byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x02, (byte) 0x3e, (byte) 0x42, (byte) 0x3e, (byte) 0x00,// a
			(byte) 0x00, (byte) 0x40, (byte) 0x7c, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x7c, (byte) 0x00,// b
			(byte) 0x00, (byte) 0x00, (byte) 0x3e, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x3e, (byte) 0x00,// c
			(byte) 0x00, (byte) 0x02, (byte) 0x3e, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x3e, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x7e, (byte) 0x40, (byte) 0x3c, (byte) 0x00,
			(byte) 0x00, (byte) 0x1c, (byte) 0x22, (byte) 0x20, (byte) 0x78, (byte) 0x20, (byte) 0x20, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x3e, (byte) 0x42, (byte) 0x42, (byte) 0x3e, (byte) 0x02, (byte) 0x3c,
			(byte) 0x00, (byte) 0x40, (byte) 0x40, (byte) 0x7c, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x00,
			(byte) 0x10, (byte) 0x00, (byte) 0x30, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x38, (byte) 0x00,
			(byte) 0x00, (byte) 0x08, (byte) 0x00, (byte) 0x08, (byte) 0x08, (byte) 0x08, (byte) 0x48, (byte) 0x30,
			(byte) 0x00, (byte) 0x20, (byte) 0x20, (byte) 0x24, (byte) 0x38, (byte) 0x24, (byte) 0x22, (byte) 0x00,
			(byte) 0x00, (byte) 0x30, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x38, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x24, (byte) 0x5a, (byte) 0x5a, (byte) 0x42, (byte) 0x42, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x7c, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x3c, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x7c, (byte) 0x42, (byte) 0x42, (byte) 0x7c, (byte) 0x40, (byte) 0x40,
			(byte) 0x00, (byte) 0x00, (byte) 0x3e, (byte) 0x42, (byte) 0x42, (byte) 0x3e, (byte) 0x02, (byte) 0x02,
			(byte) 0x00, (byte) 0x00, (byte) 0x5c, (byte) 0x62, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x3e, (byte) 0x60, (byte) 0x3c, (byte) 0x06, (byte) 0x7c, (byte) 0x00,
			(byte) 0x00, (byte) 0x20, (byte) 0x7c, (byte) 0x20, (byte) 0x20, (byte) 0x24, (byte) 0x18, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x3e, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x24, (byte) 0x18, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x42, (byte) 0x42, (byte) 0x5a, (byte) 0x5a, (byte) 0x24, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x42, (byte) 0x24, (byte) 0x18, (byte) 0x24, (byte) 0x42, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x42, (byte) 0x42, (byte) 0x42, (byte) 0x3e, (byte) 0x02, (byte) 0x3c,
			(byte) 0x00, (byte) 0x00, (byte) 0x7e, (byte) 0x04, (byte) 0x18, (byte) 0x20, (byte) 0x7e, (byte) 0x00,
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x81,
			(byte) 0x81, (byte) 0x81, (byte) 0x81, (byte) 0x81, (byte) 0x81, (byte) 0x81, (byte) 0x81, (byte) 0x81,
			(byte) 0x81, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x81,
			(byte) 0xff, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff
		};
	static final byte[] font6 = {// chars. 32 to 126
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // !
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // "
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // #
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // $
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // %
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // &
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // '
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // (
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // )
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // *
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // +
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // ,
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // -
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // .
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x00, // /
			(byte) 0x00, (byte) 0x00, (byte) 0x0c, (byte) 0x18, (byte) 0x30, (byte) 0x60, (byte) 0x40, (byte) 0x00, // 0
			(byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x4c, (byte) 0x54, (byte) 0x64, (byte) 0x38, (byte) 0x00, // 1
			(byte) 0x00, (byte) 0x00, (byte) 0x08, (byte) 0x18, (byte) 0x08, (byte) 0x08, (byte) 0x08, (byte) 0x00, // 2
			(byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x04, (byte) 0x38, (byte) 0x40, (byte) 0x7c, (byte) 0x00, // 3
			(byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x04, (byte) 0x38, (byte) 0x04, (byte) 0x78, (byte) 0x00, // 4
			(byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x28, (byte) 0x48, (byte) 0x7c, (byte) 0x08, (byte) 0x00, // 5
			(byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x40, (byte) 0x78, (byte) 0x04, (byte) 0x78, (byte) 0x00, // 6
			(byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x40, (byte) 0x78, (byte) 0x44, (byte) 0x38, (byte) 0x00, // 7
			(byte) 0x00, (byte) 0x00, (byte) 0x7c, (byte) 0x04, (byte) 0x08, (byte) 0x10, (byte) 0x10, (byte) 0x00, // 8
			(byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x44, (byte) 0x38, (byte) 0x44, (byte) 0x38, (byte) 0x00, // 9
			(byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x44, (byte) 0x3c, (byte) 0x04, (byte) 0x38, (byte) 0x00, // :
			(byte) 0x00, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x00, (byte) 0x18, (byte) 0x18, (byte) 0x00, // ;
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // <
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // =
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // >
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // ?
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // @
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // A
			(byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x44, (byte) 0x7c, (byte) 0x44, (byte) 0x44, (byte) 0x00, // B
			(byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x44, (byte) 0x78, (byte) 0x44, (byte) 0x78, (byte) 0x00, // C
			(byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x3c, (byte) 0x00, // D
			(byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x44, (byte) 0x44, (byte) 0x44, (byte) 0x78, (byte) 0x00, // E
			(byte) 0x00, (byte) 0x00, (byte) 0x7c, (byte) 0x40, (byte) 0x78, (byte) 0x40, (byte) 0x7c, (byte) 0x00, // F
			(byte) 0x00, (byte) 0x00, (byte) 0x7c, (byte) 0x40, (byte) 0x78, (byte) 0x40, (byte) 0x40, (byte) 0x00, // G
			(byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x40, (byte) 0x4c, (byte) 0x44, (byte) 0x3c, (byte) 0x00, // H
			(byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x7c, (byte) 0x44, (byte) 0x44, (byte) 0x00, // I
			(byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x38, (byte) 0x00, // J
			(byte) 0x00, (byte) 0x00, (byte) 0x04, (byte) 0x04, (byte) 0x04, (byte) 0x44, (byte) 0x38, (byte) 0x00, // K
			(byte) 0x00, (byte) 0x00, (byte) 0x24, (byte) 0x28, (byte) 0x30, (byte) 0x28, (byte) 0x24, (byte) 0x00, // L
			(byte) 0x00, (byte) 0x00, (byte) 0x20, (byte) 0x20, (byte) 0x20, (byte) 0x20, (byte) 0x3c, (byte) 0x00, // M
			(byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x6c, (byte) 0x54, (byte) 0x44, (byte) 0x44, (byte) 0x00, // N
			(byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x64, (byte) 0x54, (byte) 0x4c, (byte) 0x44, (byte) 0x00, // O
			(byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x44, (byte) 0x44, (byte) 0x44, (byte) 0x38, (byte) 0x00, // P
			(byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x44, (byte) 0x78, (byte) 0x40, (byte) 0x40, (byte) 0x00, // Q
			(byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x44, (byte) 0x44, (byte) 0x44, (byte) 0x38, (byte) 0x0c, // R
			(byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x44, (byte) 0x78, (byte) 0x50, (byte) 0x4c, (byte) 0x00, // S
			(byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x40, (byte) 0x38, (byte) 0x04, (byte) 0x78, (byte) 0x00, // T
			(byte) 0x00, (byte) 0x00, (byte) 0x7c, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x00, // U
			(byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x44, (byte) 0x44, (byte) 0x3c, (byte) 0x00, // V
			(byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x44, (byte) 0x28, (byte) 0x10, (byte) 0x00, // W
			(byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x54, (byte) 0x6c, (byte) 0x44, (byte) 0x00, // X
			(byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x28, (byte) 0x10, (byte) 0x28, (byte) 0x44, (byte) 0x00, // Y
			(byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x28, (byte) 0x10, (byte) 0x10, (byte) 0x00, // Z
			(byte) 0x00, (byte) 0x00, (byte) 0x7c, (byte) 0x08, (byte) 0x10, (byte) 0x20, (byte) 0x7c, (byte) 0x00, // [
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // \
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // ]
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // ^
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // _
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // `
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // a
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x04, (byte) 0x7c, (byte) 0x3c, (byte) 0x00, // b
			(byte) 0x00, (byte) 0x00, (byte) 0x40, (byte) 0x78, (byte) 0x44, (byte) 0x44, (byte) 0x78, (byte) 0x00, // c
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x40, (byte) 0x40, (byte) 0x38, (byte) 0x00, // d
			(byte) 0x00, (byte) 0x00, (byte) 0x04, (byte) 0x3c, (byte) 0x44, (byte) 0x44, (byte) 0x3c, (byte) 0x00, // e
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x7c, (byte) 0x40, (byte) 0x38, (byte) 0x00, // f
			(byte) 0x00, (byte) 0x00, (byte) 0x0c, (byte) 0x10, (byte) 0x3c, (byte) 0x10, (byte) 0x10, (byte) 0x00, // g
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x44, (byte) 0x3c, (byte) 0x04, (byte) 0x00, // h
			(byte) 0x00, (byte) 0x00, (byte) 0x40, (byte) 0x58, (byte) 0x64, (byte) 0x44, (byte) 0x44, (byte) 0x00, // i
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x30, (byte) 0x10, (byte) 0x10, (byte) 0x38, (byte) 0x00, // j
			(byte) 0x00, (byte) 0x00, (byte) 0x08, (byte) 0x08, (byte) 0x08, (byte) 0x08, (byte) 0x08, (byte) 0x70, // k
			(byte) 0x00, (byte) 0x00, (byte) 0x40, (byte) 0x48, (byte) 0x70, (byte) 0x48, (byte) 0x44, (byte) 0x00, // l
			(byte) 0x00, (byte) 0x00, (byte) 0x30, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x38, (byte) 0x00, // m
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x28, (byte) 0x7c, (byte) 0x54, (byte) 0x44, (byte) 0x00, // n
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x44, (byte) 0x44, (byte) 0x44, (byte) 0x00, // o
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x44, (byte) 0x44, (byte) 0x38, (byte) 0x00, // p
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x78, (byte) 0x44, (byte) 0x44, (byte) 0x78, (byte) 0x40, // q
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x44, (byte) 0x44, (byte) 0x3c, (byte) 0x04, // r
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x38, (byte) 0x24, (byte) 0x20, (byte) 0x20, (byte) 0x00, // s
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x1c, (byte) 0x30, (byte) 0x0c, (byte) 0x38, (byte) 0x00, // t
			(byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x38, (byte) 0x10, (byte) 0x10, (byte) 0x08, (byte) 0x00, // u
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x44, (byte) 0x3c, (byte) 0x00, // v
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x28, (byte) 0x10, (byte) 0x00, // w
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x54, (byte) 0x54, (byte) 0x6c, (byte) 0x00, // x
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x24, (byte) 0x18, (byte) 0x18, (byte) 0x24, (byte) 0x00, // y
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x44, (byte) 0x44, (byte) 0x3c, (byte) 0x04, (byte) 0x78, // z
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x3c, (byte) 0x08, (byte) 0x10, (byte) 0x3c, (byte) 0x00, // {
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // |
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // }
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // ~
			(byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, // 
	};

	static final class TextInfo {
		byte mX;
		byte mY;
		String mText;

		private TextInfo(final byte x, final byte y, final String text) {
			mX = x;
			mY = y;
			mText = text;
		}
	}

	/*
	league_text
0	dc.b	31,15,9,'DIVISION ',255
13	dc.b	31,14,13,'RACE  ',255
23	dc.b	31,6,11,'Track:  ',255
35	dc.b	'The ',255
40	dc.b	' V ',255
44	dc.b	31,3,24,'Broken by QUARTEX   Hit fire to continue',255
88	dc.b	31,15,21,'The ',255
96	dc.b	31,17,15,'RESULT',255
106	dc.b	'Race Winner: ',255
120	dc.b	'Fastest Lap: ',255
134	dc.b	31,14,11,'RESULTS TABLE',
147	dc.b	31,6,14,'DRIVER     RACED WIN LAP  PTS',255
183	dc.b	'Promotion for  ',255
199	dc.b	'Relegation for ',255
215	dc.b	' CHANGES',255
	dc.b	31,18,14,'NAME?',255
233	dc.b	' 2pts',255
239	dc.b	' 1pt',255
	dc.b	' of ',255
	dc.b	0
*/
	
	static final TextInfo[] league_text = {
			new TextInfo( (byte)15, (byte)9,"DIVISION "),
			new TextInfo( (byte)14, (byte)13,"RACE  "),
			new TextInfo( (byte)6, (byte)11,"Track:  "),
			new TextInfo( (byte)-1,  (byte)-1, "The "),
			new TextInfo( (byte)-1,  (byte)-1, " V "),
			new TextInfo( (byte)3, (byte)24,"Broken by QUARTEX   Hit fire to continue"),
			new TextInfo( (byte)15, (byte)21,"The "),
			new TextInfo( (byte)17, (byte)15,"RESULT"),
			new TextInfo( (byte)-1,  (byte)-1, "Race Winner: "),
			new TextInfo( (byte)-1,  (byte)-1, "Fastest Lap: "),
			new TextInfo( (byte)14, (byte)11,"RESULTS TABLE"),
			new TextInfo( (byte)6, (byte)14,"DRIVER     RACED WIN LAP  PTS"),
			new TextInfo( (byte)-1,  (byte)-1, "Promotion for  "),
			new TextInfo( (byte)-1,  (byte)-1, "Relegation for "),
			new TextInfo( (byte)-1,  (byte)-1, " CHANGES"),
			new TextInfo( (byte)18, (byte)14,"NAME?"),
			new TextInfo( (byte)-1,  (byte)-1, " 2pts"),
			new TextInfo( (byte)-1,  (byte)-1, " 1pt"),
			new TextInfo( (byte)-1,  (byte)-1, " of "),
	};

	/*
b_TEXT_5a69a
0	dc.b	31,17,11,'SELECT',255,
10			'Practise ',255
20	dc.b	'Start the Racing Season',255
44	dc.b	'Load/Save/Replay       ',255
68	dc.b	'Load',255
73	dc.b	'Save',255
78	dc.b	'Replay',255
85	dc.b	'Cancel',255
92	dc.b	'LOAD from Tape',255
7	dc.b	'LOAD from Disc',255
22	dc.b	'SAVE to Tape',255
35	dc.b	'SAVE to Disc',255
48	dc.b	31,7,20,'   Filename?  >',255
67	dc.b	'to the SUPER LEAGUE',255
87	dc.b	31,12,9,'SUPER DIVISION ',255
6	dc.b	'EXCELLENT DRIVING - WELL DONE',255
36	dc.b	'Hall of Fame',255
49	dc.b	0
 */
	static final TextInfo[] b_TEXT_5a69a = {
			// 0
			new TextInfo( (byte)17, (byte)11,"SELECT"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "Practise "),
			//
			new TextInfo( (byte)-1,  (byte)-1, "Start the Racing Season"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "Load/Save/Replay       "),
			//
			new TextInfo( (byte)-1,  (byte)-1, "Load"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "Save"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "Replay"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "Cancel"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "LOAD from Tape"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "LOAD from Disc"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "SAVE to Tape"),
			//
			new TextInfo( (byte)-1,  (byte)-1, "SAVE to Disc"),
			// 148
			new TextInfo( (byte)7, (byte)20,"   Filename?  >"),
			// 167
			new TextInfo( (byte)-1,  (byte)-1, "to the SUPER LEAGUE"),
			// 187
			new TextInfo( (byte)12, (byte)9,"SUPER DIVISION "),
			// 206
			new TextInfo( (byte)-1,  (byte)-1, "EXCELLENT DRIVING - WELL DONE"),
			// 236
			new TextInfo( (byte)-1,  (byte)-1, "Hall of Fame"),
	};

	/*
	main_game_selection_text
0	dc.b	31,17,11,'SELECT',255
10	dc.b	'Single Player League',255
31	dc.b	'Multiplayer',255
43	dc.b	'Enter another driver',255
64	dc.b	'Continue',255
73	dc.b	'Tracks in DIVISION ',255
93	dc.b	0,0,0,0,0,0
99	dc.b	' S.',255
103	dc.b	'        s',255
113	dc.b	'Computer Link',255
126	dc.b	'ssssssssssssssssssss'
146	dc.b	'Track:  The ',255
159	dc.b	31,10,9,'DRIVERS CHAMPIONSHIP',255
183	dc.b	31,14,20,'Track record',255
	dc.b	0

	b_TEXT_5ec48
0/201	dc.b	'------------',255
13/214	dc.b	'------------',255
27/230	dc.b	31,12,15,'New track record',255
*/
	static final TextInfo[] main_game_selection_text = {
			// 0
			new TextInfo( (byte) 17, (byte) 11, "SELECT" ),
			new TextInfo( (byte) -1, (byte) -1, "Single Player League" ),
			new TextInfo( (byte) -1, (byte) -1, "Multiplayer" ),
			new TextInfo( (byte) -1, (byte) -1, "Enter another driver" ),
			new TextInfo( (byte) -1, (byte) -1, "Continue" ),
			new TextInfo( (byte) -1, (byte) -1, "Tracks in DIVISION " ),
			null,// 6
			new TextInfo( (byte) -1, (byte) -1, " S." ),
			new TextInfo( (byte) -1, (byte) -1, "        s" ),
			new TextInfo( (byte) -1, (byte) -1, "Computer Link" ),
			new TextInfo( (byte) -1, (byte) -1, "ssssssssssssssssssss" ),
			new TextInfo( (byte) -1, (byte) -1, "Track:  The " ),
			new TextInfo( (byte) 10, (byte) 9,"DRIVERS CHAMPIONSHIP" ),
			new TextInfo( (byte) 14, (byte) 20,"Track record" ),
			// 14
			new TextInfo( (byte) -1, (byte) -1,"------------" ),
			new TextInfo( (byte) -1, (byte) -1,"------------" ),
			new TextInfo( (byte) 12, (byte) 15,"New track record" ),
			// };
			/*
			// private static final LeagueText[] TEXT_5ec48 = {
			// 0
			new LeagueText( (byte) -1, (byte) -1, "------------" ),
			// 13
			new LeagueText( (byte) -1, (byte) -1, "------------" ),
			// 27
			new LeagueText( (byte) 12, (byte) 15, "New track record" ),
			*/
	};

	static final TextInfo[] b_TAB_625ce = {
			// 0
			new TextInfo( (byte) 11, (byte) 9, "LOAD game position" ),
			// 22
			new TextInfo( (byte) 11, (byte) 9, "SAVE game position" ),
			// 44
			new TextInfo( (byte) -1, (byte) -1, "Drive not ready" ),
			// 60
			new TextInfo( (byte) -1, (byte) -1, "Disc write protected" ),
			// 81
			new TextInfo( (byte) -1, (byte) -1, "Insert disc" ),
			// 93
			new TextInfo( (byte) -1, (byte) -1, "Disc error" ),
			// 104
			new TextInfo( (byte) -1, (byte) -1, "Incorrect data found  " ),
			// 127
			new TextInfo( (byte) -1, (byte) -1, "Type in file name" ),

			// these 2 lines must be printed together
			// 145
			new TextInfo( (byte) 7, (byte) 22, "                            " ),// FIXME without 255
			// 177
			new TextInfo( (byte) 7, (byte) 23, "                            " ),

			// 209
			new TextInfo( (byte) 8, (byte) 23, "" ),
			// 212
			new TextInfo( (byte) -1, (byte) -1, "Disc error: retry or escape" ),

			// 241 these 2 lines must be printed together
			new TextInfo( (byte) 8, (byte) 22, "Warning: this disc has not" ),// FIXME without 255
			// 270
			new TextInfo( (byte) 8, (byte) 23, "been used for game saving" ),

			// 298, these 3 lines must be printed together
			new TextInfo( (byte) 5, (byte) 15, "Insert formatted game save disc" ),
			new TextInfo( (byte) 14, (byte) 17, "into drive 0." ),
			new TextInfo( (byte) 9, (byte) 20, "Press any key to continue" ),

	};

	static final TextInfo[] b_TEXT_5915e = {
			// 0
			new TextInfo( (byte) 20, (byte) 15, "V" ),
			// 5
			new TextInfo( (byte) 7, (byte) 16, "Winner 2pts     Best Lap 1pt" ),
			// 37
			new TextInfo( (byte) -1, (byte) -1, " Raced  " ),
			// 46
			new TextInfo( (byte) -1, (byte) -1, " Wins   " ),
			// 55
			new TextInfo( (byte) -1, (byte) -1, " Laps   " ),
			// 64
			new TextInfo( (byte) -1, (byte) -1, " Points " ),
			// 73
			new TextInfo( (byte) 7, (byte) 10, "First     Second     Third" )
	};

/*
b_TEXT_5ec92
0	dc.b	'TRACK BONUS POINTS',255
19	dc.b	31,14,12,'FINAL SEASON',255
35	dc.b	'Race Time: ',255
47	dc.b	'Best Lap : ',255
59	dc.b	31,16,1,'HALL of FAME',255
75	dc.b	31,16,5,'SUPER LEAGUE',255
91	dc.b	31,0,7,'TRACK  DRIVER   LAP-TIME    DRIVER  RACE-TIME',255
140	dc.b	31,6,14,'DRIVER      BEST-LAP RACE-TIME',255
*/

	static final TextInfo[] b_TEXT_5ec92 = {
			// 0
			new TextInfo( (byte) -1, (byte) -1, "TRACK BONUS POINTS" ),
			// 19
			new TextInfo( (byte) 14, (byte) 12, "FINAL SEASON" ),
			// 35
			new TextInfo( (byte) -1, (byte) -1, "Race Time: " ),
			// 47
			new TextInfo( (byte) -1, (byte) -1, "Best Lap : " ),
			// 59
			new TextInfo( (byte) 16, (byte) 1, "HALL of FAME" ),
			// 75
			new TextInfo( (byte) 16, (byte) 5, "SUPER LEAGUE" ),
			// 91
			new TextInfo( (byte) 0, (byte) 7, "TRACK  DRIVER   LAP-TIME    DRIVER  RACE-TIME" ),
			// 141
			new TextInfo( (byte) 6, (byte) 14, "DRIVER      BEST-LAP RACE-TIME" ),
	};

	static final TextInfo[] b_TEXT_5ec48 = {
			new TextInfo( (byte) -1, (byte) -1, "------------"),
			new TextInfo( (byte) -1, (byte) -1, "------------"),
			new TextInfo( (byte) 2, (byte) 15, "New track record"),
	};

	static final TextInfo[] b_LINK_TEXT_57e00 = {
			// 0
			new TextInfo( (byte) 14, (byte) 16, "Link abandoned"),
			// 18
			new TextInfo( (byte) 14, (byte) 16, "Link complete"),
			// 35
			new TextInfo( (byte) 17, (byte) 16, "Linking"),
			// 46
			new TextInfo( (byte) 15, (byte) 16, "Please wait")
	};
/*
	b_TEXT_5f636_11
0	dc.b	' NOT',255
5	dc.b	' loaded',255
13	dc.b	' saved',255
20	dc.b	'Incorrect data found ',255
42	dc.b	'File name already exists',255
67	dc.b	'Problem encountered',255
87	dc.b	'File name is not suitable',255
113	dc.b	31,5,19,'Insert game position save ',255
143	dc.b	'tape',255
148	dc.b	'disc',255
*/
	static final TextInfo[] b_TEXT_5f636_11 = {
			new TextInfo( (byte) -1, (byte) -1, " NOT"),
			new TextInfo( (byte) -1, (byte) -1, " loaded"),
			new TextInfo( (byte) -1, (byte) -1, " saved"),
			new TextInfo( (byte) -1, (byte) -1, "Incorrect data found "),
			new TextInfo( (byte) -1, (byte) -1, "File name already exists"),
			new TextInfo( (byte) -1, (byte) -1, "Problem encountered"),
			new TextInfo( (byte) -1, (byte) -1, "File name is not suitable"),
			new TextInfo( (byte) 5, (byte) 19, "Insert game position save "),
			new TextInfo( (byte) -1, (byte) -1, "tape"),
			new TextInfo( (byte) -1, (byte) -1, "disc"),
		};

	/** Offsets to {@link #b_TEXT_5f636_11} */
	static final byte[] b_TEXT_5f636 = {
			// 5, 13, 67, 20, 42, 67, 67, 67, 113, 143, 148
			1, 2, 5, 3, 4, 5, 5, 5, 7, 8, 9
	};

	// b_race_prompt_text
	/*
	dc.b	3,'<WRCECK'			0
	dc.b	3,' RACCE !< WaON aT  '		8
	dc.b	3,' RACCE ! LOaST '		28
	dc.b	3,' DRCOP !<STaART'		44
	dc.b	3,'<PRCESS! FIaRE '		60
	dc.b	3,'PAUCSED'			76
	dc.b	3,' LACPS ! OVaER '		84
	dc.b	3,'DEFCINE! KEaYS '		100
	dc.b	3,'<STCEER! LEaFT '		116
	dc.b	3,'<STCEER!<RIaGHT'		132
	dc.b	3,'<AHCEAD!+BOaOST'		148
	dc.b	3,' BACCK !+BOaOST'		164
	dc.b	3,' BACCK !   a   '		180
	dc.b	3,'VERCIFY! KEaYS '		196
	dc.b	3,'<FACULT!<FOaUND<T'		212
	dc.b	6,26
	 */
	/* private static final String[] race_prompt_text = {
			"WRECK", "RACE WON", "RACE LOST", "DROP START",
			"PRESS FIRE", "PAUSED", "LAPS OVER", "DEFINE KEYS",
			"STEER LEFT", "STEER RIGHT", "AHEAD BOOST", "BACK BOOST",
			"BACK", "VERIFY KEYS", "FAULT FOUND"
		}; */
	static final String STR_WRECK = "<WRECK";
	static final String STR_RACE_WON = " RACE !< WON";
	static final String STR_RACE_LOST = " RACE ! LOST";
	static final String STR_DROP_START = " DROP !<START";
	static final String STR_PRESS_FIRE = "<PRESS! FIRE";
	static final String STR_PAUSED = "PAUSED";
	static final String STR_LAPS_OVER = " LAPS ! OVER";
	static final String STR_DEFINE_KEYS = "DEFINE! KEYS";
	private static final String STR_STEER_LEFT = "<STEER! LEFT";
	private static final String STR_STEER_RIGHT = "<STEER!<RIGHT";
	private static final String STR_AHEAD_BOOST = "<AHEAD!+BOOST";
	private static final String STR_BACK_BOOST = " BACK!+BOOST";
	private static final String STR_BACK = " BACK !   a";
	static final String STR_VERIFY_KEYS = "VERIFY! KEYS";
	static final String STR_FAULT_FOUND = "<FAULT!<FOUND";

	static final String[] b_TAB_5fadc_7 = {
			STR_BACK,// (byte) 180,
			STR_BACK_BOOST,// (byte) 164,
			STR_AHEAD_BOOST,// (byte) 148,
			STR_STEER_RIGHT,// (byte) 132,
			STR_STEER_LEFT,// (byte) 116
	};

	static final int OPPONENTS_NAME_STORE_LENGTH = 14;
	static final int OPPONENTS_NAME_FULL_LENGTH = 16;
	static final int RACER_NAME_LENGTH = 12;

	/** 12 names by 16 chars, 1st char is not used, each name is 14 chars max */
	static final char[][] opponents_names_sources = {
			" Hot Rod      \r\n".toCharArray(),// 0
			" Whizz Kid    \r\n".toCharArray(),// 16
			" Bad Guy      \r\n".toCharArray(),// 32
			" The Dodger   \r\n".toCharArray(),// 48
			" Big Ed       \r\n".toCharArray(),// 64
			" Max Boost    \r\n".toCharArray(),// 80
			" Dare Devil   \r\n".toCharArray(),// 96
			" High Flyer   \r\n".toCharArray(),// 112
			" Bully Boy    \r\n".toCharArray(),// 128
			" Jumping Jack \r\n".toCharArray(),// 144
			" Road Hog     \r\n".toCharArray(),// 160
			"              \r\n".toCharArray()// 176
	};

	// TODO java: use string or chars
	static final byte[] b_TEXT_7a61a = {
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0
	};

	static final byte[] b_TEXT_7a71a = {
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0,
			'-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', 9, 0, 0, 0
	};
}
