package utils;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public final class Utils {
	private static void makePicture() {
		try {
			BufferedImage img = ImageIO.read(
					new File("img.png"));
			BufferedImage res = new BufferedImage( 320, 200, BufferedImage.TYPE_INT_ARGB );
			for( int y = 0; y < 2*200; y += 2 ) {
				for( int x = 0; x < 2*320; x += 2 ) {
					// int color = img.getRGB( x + 59, y + 103 );
					int color = img.getRGB( x + 59, y + 96 );
					// int color = img.getRGB( x + 59, y + 65 );
					res.setRGB( x >> 1, y >> 1, color );
				}
			}
			ImageIO.write( res, "png", new File("temp.png") );
		} catch ( IOException e) {
		}
		return;
	}

	private static void makeFont6() {
		try {
			final char[] chars = {
					'.', '/',
					'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
					':', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
					'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
					'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
					'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u',
					'v', 'w', 'x', 'y', 'z'

			};
			BufferedImage img = ImageIO.read( new File("font6.png") );
			final byte[] masks = new byte[ (127 - 32) * 8 ];
			int char_index = 0;
			for( int y = 0; y < img.getHeight(); y += 2 * 8 ) {
				for( int px = 0; px < img.getWidth(); px += 2 * 6 ) {
					for( int sy = 0; sy < 8; sy++ ) {
						byte mask = 0;
						for( int sx = 0; sx < 6; sx++ ) {
							int color = img.getRGB( px + sx * 2, y + sy * 2 );
							if( color == 0xFF000000 ) {
								mask |= 1 << (7 - sx);
							}
						}
						if( char_index < chars.length ) {
							masks[ (chars[ char_index ] - ' ') * 8 + sy ] = mask;
						}
					}
					char_index++;
				}
			}
			for( int i = 0; i < masks.length; ) {
				for( int y = 0; y < 8; y++, i++ ) {
					System.out.printf( "(byte) 0x%02x, ", masks[ i ] );
				}
				if( (i & 0x7) == 0 ) {
					System.out.println("// " + Character.valueOf( (char) (i / 8 + ' ')) );
				}
			}
		} catch(final Exception e) {
			e.printStackTrace();
		}
	}
}
